'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var classnames = require('classnames');
var utilsCommons = require('@highlight-ui/utils-commons');
var utilsHooks = require('@highlight-ui/utils-hooks');
var typography = require('@highlight-ui/typography');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles$1 = {
  "radioButtonLabelText": "RadioButton-module__VSkjLhDR__v4-2-32",
  "radioButtonInput": "RadioButton-module__Fyk408Rt__v4-2-32",
  "radioButtonLabel": "RadioButton-module__EX4nE3hP__v4-2-32",
  "radioButton": "RadioButton-module__Ntx5MSTi__v4-2-32",
  "radioButtonSubLabel": "RadioButton-module__Qj-IC6oh__v4-2-32"
};
var RadioButtonWithRef = function (_a, ref) {
  var label = _a.label,
    subLabel = _a.subLabel,
    className = _a.className,
    metadata = _a.metadata,
    id = _a.id,
    disabled = _a.disabled,
    radioProps = __rest(_a, ["label", "subLabel", "className", "metadata", "id", "disabled"]);
  var generatedId = utilsHooks.useId('radioButton-');
  var inputId = id || generatedId;
  return React__default["default"].createElement("span", __assign({
    className: classnames__default["default"](className, styles$1.radioButton)
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement("input", __assign({
    ref: ref,
    id: inputId,
    type: "radio",
    disabled: disabled,
    className: styles$1.radioButtonInput
  }, radioProps)), React__default["default"].createElement("label", {
    htmlFor: inputId,
    className: styles$1.radioButtonLabel
  }, label && React__default["default"].createElement(typography.Typography, {
    title: label,
    token: "body-base",
    component: "span",
    color: disabled ? 'text-disabled' : 'text-default',
    className: styles$1.radioButtonLabelText
  }, label)), label && subLabel && React__default["default"].createElement(typography.Typography, {
    title: subLabel,
    token: "caption",
    component: "span",
    color: disabled ? 'text-disabled' : 'text-subdued',
    className: styles$1.radioButtonSubLabel
  }, subLabel));
};
RadioButtonWithRef.displayName = 'RadioButton';
var RadioButton = React__default["default"].forwardRef(RadioButtonWithRef);
var styles = {
  "radioButtonGroup": "RadioButtonGroup-module__J8q4xTRb__v4-2-32",
  "radioButtonGroupOption": "RadioButtonGroup-module__MqF3JZqH__v4-2-32",
  "radioButtonGroupHorizontal": "RadioButtonGroup-module__Bq7nC20K__v4-2-32"
};
var RadioButtonGroupWithRef = function (_a, ref) {
  var _b;
  var className = _a.className,
    metadata = _a.metadata,
    name = _a.name,
    _c = _a.disabled,
    disabled = _c === void 0 ? false : _c,
    _d = _a.orientation,
    orientation = _d === void 0 ? 'vertical' : _d,
    options = _a.options,
    value = _a.value,
    _e = _a.onChange,
    onChange = _e === void 0 ? utilsCommons.noop : _e;
  var generatedName = utilsHooks.useId('radioButtonGroupOption-');
  var radioButtonGroupName = name || generatedName;
  return React__default["default"].createElement("div", __assign({
    ref: ref,
    className: classnames__default["default"](className, styles.radioButtonGroup, (_b = {}, _b[styles.radioButtonGroupHorizontal] = orientation === 'horizontal', _b))
  }, utilsCommons.parseMetadata(metadata)), options.map(function (option) {
    return React__default["default"].createElement(RadioButton, {
      key: option.value + "-" + radioButtonGroupName,
      metadata: option.metadata,
      className: classnames__default["default"](option.className, styles.radioButtonGroupOption),
      id: option.id,
      label: option.label,
      subLabel: option.subLabel,
      value: option.value,
      disabled: disabled || option.disabled,
      checked: value === option.value,
      name: radioButtonGroupName,
      onChange: function () {
        return onChange(option);
      }
    });
  }));
};
RadioButtonGroupWithRef.displayName = 'RadioButtonGroup';
var RadioButtonGroup = React__default["default"].forwardRef(RadioButtonGroupWithRef);
exports.RadioButton = RadioButton;
exports.RadioButtonGroup = RadioButtonGroup;
//# sourceMappingURL=index.js.map
