import React from 'react';
import { PropsWithMetadata } from '@highlight-ui/utils-commons';
export declare type RadioButtonProps = PropsWithMetadata<{
    /** Allows providing a custom class name */
    className?: string;
    /** Text that will be displayed next to the actual radio button */
    label?: string;
    /** Grayed-out piece of text that will be displayed below the label */
    subLabel?: string;
}> & React.ComponentPropsWithoutRef<'input'>;
declare const RadioButton: React.ForwardRefExoticComponent<{
    /** Allows providing a custom class name */
    className?: string | undefined;
    /** Text that will be displayed next to the actual radio button */
    label?: string | undefined;
    /** Grayed-out piece of text that will be displayed below the label */
    subLabel?: string | undefined;
} & {
    metadata?: import("@highlight-ui/utils-commons").ComponentMetadata | undefined;
} & Pick<React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>, "key" | keyof React.InputHTMLAttributes<HTMLInputElement>> & React.RefAttributes<HTMLInputElement>>;
export default RadioButton;
